import datetime

from djangotools.common.types import date_to_string
from baby.app.context.base import BaseContextData, UserPrefences
from baby.app.models.regle import Regle


class EditData(BaseContextData):
    page = "edit"


    def get_context_data(self, request, action_params, **kwargs):
        user = request.user
        debut = datetime.date.today()
        if "year" in getattr(request, "GET", {}):
            debut =datetime.date(int(request.GET["year"]), 1, 1)
        elif "year" in getattr(request, "POST", {}):
            debut = datetime.date(int(request.POST["year"]), 1, 1)
        else:
            debut = datetime.date(debut.year, 1 , 1)

        fin = datetime.date(debut.year+1, 1, 1)

        regles = Regle.objects.filter(user=user, date__gte=debut, date__lt=fin)
        return {
            "year" : debut.year,
            "dates" : [{"date": date_to_string(x.date), "id": x.id} for x in regles],
            "prev" : debut.year - 1,
            "next" : debut.year + 1,
            "count" : len(regles),
            "title" : "Editer les cycles"
        }
