import datetime

from djangotools.common.types import parse_date

from baby.app.context.base import BaseContextData, UserPrefences
from baby.app.models.const import get_min_period
from baby.app.models.regle import Regle

class ContextData(BaseContextData):
    page = "validate_cycle"

    def get_context_data(self, request, action_params, **kwargs):
        user = request.user
        params = request.GET
        force = params.get("force", False)
        date = params.get("date",datetime.date.today())
        if isinstance(date, (list, tuple)):
            if date: date = date[0]
            else: date=None
        today = parse_date(date)


        last = Regle.objects.last_regle_before(user, today)
        if last is not None:
            days_from_begin = (today - last.date).days

            if days_from_begin == 0:
                return {
                    "status": False,
                    "message": "Le cycle a déja été initialisé aujourd'hui"
                }

            if days_from_begin < get_min_period(user) and not force:
                return {
                    "status" :  False,
                    "message" : "Le cycle est trop court"
                }

        Regle.objects.create(user, today)
        return {
            "status" :  True,
            "message" : "Le nouveau cycle a bien été pris en compte"
        }


